
'LARGE THREE-LINE PRINT DECIMAL NUMBER FROM -999.9 TO 999.9 FROM SINGLE VARIABLE

'Command: Big_number y , x , Single variable

'Suitable for printing positive  or negative temperatures, etc.

'Print in 18 columns on LCD

'SPACE = 255, Minus = 253, Decimal point = 254

' Mladen Cempuh 18.01.2024. ; cempuh.mladen@gmail.com
'----------------------------------------------------------------------------

Config Submode = New

Deflcdchar 0 , 32 , 32 , 32 , 32 , 14 , 14 , 14 , 14        ' Char 0 --> decimal point

Deflcdchar 1 , 31 , 31 , 31 , 31 , 31 , 32 , 32 , 32        ' Char 1

Deflcdchar 2 , 32 , 32 , 32 , 31 , 31 , 31 , 31 , 31        ' Char 2

Deflcdchar 3 , 31 , 31 , 31 , 31 , 31 , 31 , 15 , 7         ' Char 3

Deflcdchar 4 , 28 , 30 , 31 , 31 , 31 , 31 , 31 , 31        ' Char 4

Deflcdchar 5 , 32 , 7 , 15 , 31 , 31 , 31 , 31 , 31         ' Char 5

Deflcdchar 6 , 32 , 31 , 31 , 31 , 31 , 32 , 32 , 32        ' Char 6

Deflcdchar 7 , 32 , 28 , 30 , 31 , 31 , 31 , 31 , 31        ' Char 7

Home

Dim Lcd_ar(7) As Byte , Lcd_num_string As String * 6

Goto End_big_number

'==================== Command: Big_number y , x , Single variable ======================

Sub Big_number(byval Pos_y As Byte , Byval Pos_x As Byte , Byval Number_x As Single)

 Local N As Byte

 If Number_x < -999.9 Or Number_x > 999.9 Then

  Locate Pos_y , Pos_x : Lcd "**Over range!**"

  Goto Lab_end_sub

 End If

 Lcd_num_string = Fusing(number_x , "####.#")

 For N = 2 To 7

 Lcd_ar(n) = 0

 Next N

 Str2digits Lcd_num_string , Lcd_ar(1)

 If Lcd_ar(6) = 0 And Lcd_ar(5) = 0 Then Lcd_ar(5) = 255

 If Lcd_ar(6) = 0 Then Lcd_ar(6) = 255

 If Lcd_ar(7) = 0 Then Lcd_ar(7) = 255

 Locate Pos_y , Pos_x                                       ' print the first line on LCD

For N = 7 To 2 Step -1

  Gosub Correct_print_position                              ' correct print position of minus or print space between
                                                             ' digits hundred and ten and digits ten and one
  Select Case Lcd_ar(n)

      Case 255 : Lcd "   ";                                 '1st line of space

      Case 254 : Lcd " ";                                   '1st line of decimal point

      Case 253 : Lcd "   ";                                 '1st line of minus

      Case 0 : Lcd Chr(255) ; Chr(1) ; Chr(4);              '1st line of 0

      Case 1 : Lcd Chr(1) ; Chr(4) ; " ";                   '1st line of 1

      Case 2 : Lcd Chr(1) ; Chr(1) ; Chr(4);                '1st line of 2

      Case 3 : Lcd Chr(1) ; Chr(1) ; Chr(4);                '1st line of 3

      Case 4 : Lcd Chr(255) ; " " ; Chr(255);               '1st line of 4

      Case 5 : Lcd Chr(255) ; Chr(1) ; Chr(1);              '1st line of 5

      Case 6 : Lcd Chr(255) ; Chr(1) ; Chr(1);              '1st line of 6

      Case 7 : Lcd Chr(1) ; Chr(1) ; Chr(255);              '1st line of 7

      Case 8 : Lcd Chr(255) ; Chr(1) ; Chr(4);              '1st line of 8

      Case 9 : Lcd Chr(255) ; Chr(1) ; Chr(4);              '1st line of 9

  End Select

  Next N

  N = Pos_y + 1

  Locate N , Pos_x                                          ' print the second line on LCD

 For N = 7 To 2 Step -1

  Gosub Correct_print_position                              ' correct print position of minus or print space between
                                                             ' digits hundred and ten and digits ten and one
  Select Case Lcd_ar(n)

      Case 255 : Lcd "   ";                                 '2nd line of space

      Case 254 : Lcd " ";                                   '2nd line of decimal point

      Case 253 : Lcd Chr(6) ; Chr(6) ; " ";                 '2nd line of minus

      Case 0 : Lcd Chr(255) ; " " ; Chr(255);               '2nd line of 0

      Case 1 : Lcd " " ; Chr(255) ; " ";                    '2nd line of 1

      Case 2 : Lcd Chr(5) ; Chr(6) ; Chr(1);                '2nd line of 2

      Case 3 : Lcd " " ; Chr(6) ; Chr(4);                   '2nd line of 3

      Case 4 : Lcd Chr(1) ; Chr(6) ; Chr(255);              '2nd line of 4

      Case 5 : Lcd Chr(1) ; Chr(6) ; Chr(7);                '2nd line of 5

      Case 6 : Lcd Chr(255) ; Chr(6) ; Chr(7);              '2nd line of 6

      Case 7 : Lcd " " ; Chr(5) ; Chr(1);                   '2nd line of 7

      Case 8 : Lcd Chr(255) ; Chr(6) ; Chr(255);            '2nd line of 8

      Case 9 : Lcd Chr(1) ; Chr(6) ; Chr(255);              '2nd line of 9

  End Select

  Next N

  N = Pos_y + 2

  Locate N , Pos_x                                          ' print the third line on LCD

 For N = 7 To 2 Step -1

  Gosub Correct_print_position                              ' correct print position of minus or print space between
                                                             ' digits hundred and ten and digits ten and one
  Select Case Lcd_ar(n)

      Case 255 : Lcd "   ";                                 '3rd line of space

      Case 254 : Lcd Chr(0);                                '3rd line of decimal point

      Case 253 : Lcd "   ";                                 '3rd line of minus

      Case 0 : Lcd Chr(3) ; Chr(2) ; Chr(255);              '3rd line of 0

      Case 1 : Lcd Chr(2) ; Chr(255) ; Chr(2);              '3rd line of 1

      Case 2 : Lcd Chr(255) ; Chr(2) ; Chr(2);              '3rd line of 2

      Case 3 : Lcd Chr(3) ; Chr(2) ; Chr(255);              '3rd line of 3

      Case 4 : Lcd "  " ; Chr(255);                         '3rd line of 4

      Case 5 : Lcd Chr(2) ; Chr(2) ; Chr(255);              '3rd line of 5

      Case 6 : Lcd Chr(3) ; Chr(2) ; Chr(255);              '3rd line of 6

      Case 7 : Lcd " " ; Chr(255) ; " ";                    '3rd line of 7

      Case 8 : Lcd Chr(3) ; Chr(2) ; Chr(255);              '3rd line of 8

      Case 9 : Lcd "  " ; Chr(255);                         '3rd line of 9

  End Select

  Next N

 Goto Lab_end_sub

 Correct_print_position:

  If N = 6 And Lcd_ar(6) = 253 Then Lcd " ";                ' shift the minus one place to the right

  If N = 5 And Lcd_ar(6) <> 253 Then Lcd " ";               ' the space between the digits of hundred and ten

  If N = 5 And Lcd_ar(5) = 253 Then Lcd " ";                ' shift the minus one place to the right

  If N = 4 And Lcd_ar(5) <> 253 Then Lcd " ";               ' the space between the digits of ten and one

 Return

Lab_end_sub:

End Sub

End_big_number: