'Cetveroredni format ispisa Single varijable na LCD
'u opsegu od -99.9 do 99.9

$regfile = "m328pdef.dat"
$crystal = 16000000
$swstack = 50
$hwstack = 40
$framesize = 64

'Mladen Cempuh , 11.2024.
'------------------------------------------------------------
'DEFINIRANJE LCD DISPLEJA U 4 BITNOM RADU

Config Lcd = 20 * 4                                         ' izbor LCD2004

Config Lcdpin = Pin , Db4 = Portc.3 , Db5 = Portc.2 , Db6 = Portb.5 , Db7 = Portb.4 , Rs = Portc.5 , E = Portc.4
Cls
Cursor Off

'-------------------------------------------------------------

$include "4_rows_single_99.9.inc"                           ' knjizica za cetveroredni ispis decimalnog broja od -99.9 do 99.9
                                                             ' iz Single varijable
'-------------------------------------------------------------

Dim X As Single

Locate 1 , 17 : Lcd Chr(223) ; "C"                          ' C

Do

 For X = -99.9 To 99.9 Step 3.2

 Big_number 1 , 2 , X                                       ' ispisi na poziciju y = 1, x = 2, decimalni broj u Single varijabli X

 Wait 1

 Next X

Loop

End