'LARGE FOUR-LINE PRINT POSITIVE NUMBER FROM 0 TO 65535 FROM WORD VARIABLE

'Command: Big_number y , x , Word variable

'Suitable for frequency, number of pieces, etc.

'Print in 19 columns on LCD

'SPACE = 255

' Mladen Cempuh 18.01.2024. ; cempuh.mladen@gmail.com
'----------------------------------------------------------------------------

Config Submode = New

Deflcdchar 1 , 32 , 32 , 32 , 32 , 31 , 31 , 31 , 31        ' Char 1

Deflcdchar 2 , 31 , 31 , 31 , 31 , 32 , 32 , 32 , 32        ' Char 2

Deflcdchar 3 , 1 , 7 , 15 , 15 , 31 , 31 , 31 , 31          ' Char 3

Deflcdchar 4 , 16 , 28 , 30 , 30 , 31 , 31 , 31 , 31        ' Char 4

Deflcdchar 5 , 31 , 31 , 31 , 31 , 15 , 15 , 7 , 1          ' Char 5

Deflcdchar 6 , 31 , 31 , 31 , 31 , 30 , 30 , 28 , 16        ' Char 6

Deflcdchar 7 , 32 , 32 , 32 , 32 , 24 , 30 , 31 , 31        ' Char 7

Home

Dim Lcd_ar(6) As Byte , Lcd_num_string As String * 5

Goto End_big_number

'==================== Command: Big_number y , x , Word variable ======================

Sub Big_number(byval Pos_y As Byte , Byval Pos_x As Byte , Byval Number_x As Word)

 Local N As Byte

 Lcd_num_string = Str(number_x)

 For N = 2 To 6

 Lcd_ar(n) = 0

 Next N

 Str2digits Lcd_num_string , Lcd_ar(1)

 If Lcd_ar(6) = 0 Then

   Lcd_ar(6) = 255

    If Lcd_ar(5) = 0 Then

     Lcd_ar(5) = 255

      If Lcd_ar(4) = 0 Then

       Lcd_ar(4) = 255

        If Lcd_ar(3) = 0 Then

         Lcd_ar(3) = 255

        End If

      End If

    End If

 End If

 Locate Pos_y , Pos_x                                       ' print the first line on LCD

 For N = 6 To 2 Step -1

      If N < 6 Then Lcd " ";                                ' the space between the digits

  Select Case Lcd_ar(n)

      Case 255 : Lcd "   ";                                 '1st line of space

      Case 0 : Lcd Chr(3) ; Chr(2) ; Chr(4);                '1st line of 0

      Case 1 : Lcd Chr(2) ; Chr(4) ; " ";                   '1st line of 1

      Case 2 : Lcd Chr(3) ; Chr(2) ; Chr(4);                '1st line of 2

      Case 3 : Lcd Chr(3) ; Chr(2) ; Chr(4);                '1st line of 3

      Case 4 : Lcd Chr(255) ; " " ; Chr(255);               '1st line of 4

      Case 5 : Lcd Chr(255) ; Chr(2) ; Chr(2);              '1st line of 5

      Case 6 : Lcd Chr(3) ; Chr(2) ; Chr(2);                '1st line of 6

      Case 7 : Lcd Chr(2) ; Chr(2) ; Chr(255);              '1st line of 7

      Case 8 : Lcd Chr(3) ; Chr(2) ; Chr(4);                '1st line of 8

      Case 9 : Lcd Chr(3) ; Chr(2) ; Chr(4);                '1st line of 9

  End Select

  Next N

  N = Pos_y + 1

  Locate N , Pos_x                                          ' print the second line on LCD

  For N = 6 To 2 Step -1

     If N < 6 Then Lcd " ";                                 ' the space between the digits

  Select Case Lcd_ar(n)

      Case 255 : Lcd "   ";                                 '2nd line of space

      Case 0 : Lcd Chr(255) ; " " ; Chr(255);               '2nd line of 0

      Case 1 : Lcd " " ; Chr(255) ; " ";                    '2nd line of 1

      Case 2 : Lcd " " ; Chr(1) ; Chr(6);                   '2nd line of 2

      Case 3 : Lcd " " ; Chr(1) ; Chr(6);                   '2nd line of 3

      Case 4 : Lcd Chr(5) ; Chr(1) ; Chr(255);              '2nd line of 4

      Case 5 : Lcd Chr(5) ; Chr(1) ; Chr(7);                '2nd line of 5

      Case 6 : Lcd Chr(255) ; Chr(1) ; Chr(7);              '2nd line of 6

      Case 7 : Lcd "  " ; Chr(6) ;                          '2nd line of 7

      Case 8 : Lcd Chr(5) ; Chr(1) ; Chr(6);                '2nd line of 8

      Case 9 : Lcd Chr(5) ; Chr(1) ; Chr(255);              '2nd line of 9

  End Select

  Next N

  N = Pos_y + 2

  Locate N , Pos_x                                          ' print the third line on LCD

  For N = 6 To 2 Step -1

     If N < 6 Then Lcd " ";                                 ' the space between the digits

  Select Case Lcd_ar(n)

      Case 255 : Lcd "   ";                                 '3rd line of space

      Case 0 : Lcd Chr(255) ; " " ; Chr(255);               '3rd line of 0

      Case 1 : Lcd " " ; Chr(255) ; " ";                    '3rd line of 1

      Case 2 : Lcd Chr(3) ; "  ";                           '3rd line of 2

      Case 3 : Lcd "  " ; Chr(4) ;                          '3rd line of 3

      Case 4 : Lcd "  " ; Chr(255);                         '3rd line of 4

      Case 5 : Lcd "  " ; Chr(255);                         '3rd line of 5

      Case 6 : Lcd Chr(255) ; " " ; Chr(255);               '3rd line of 6

      Case 7 : Lcd " " ; Chr(3) ; " ";                      '3rd line of 7

      Case 8 : Lcd Chr(3) ; " " ; Chr(4);                   '3rd line of 8

      Case 9 : Lcd "  " ; Chr(255);                         '3rd line of 9

  End Select

  Next N

  N = Pos_y + 3

  Locate N , Pos_x                                          ' print the fourth line on LCD

  For N = 6 To 2 Step -1

     If N < 6 Then Lcd " ";                                 ' the space between the digits

  Select Case Lcd_ar(n)

      Case 255 : Lcd "   ";                                 '4th line of space

      Case 0 : Lcd Chr(5) ; Chr(1) ; Chr(6);                '4th line of 0

      Case 1 : Lcd Chr(1) ; Chr(255) ; Chr(1);              '4th line of 1

      Case 2 : Lcd Chr(255) ; Chr(1) ; Chr(1);              '4th line of 2

      Case 3 : Lcd Chr(5) ; Chr(1) ; Chr(6);                '4th line of 3

      Case 4 : Lcd "  " ; Chr(255);                         '4th line of 4

      Case 5 : Lcd Chr(5) ; Chr(1) ; Chr(6);                '4th line of 5

      Case 6 : Lcd Chr(5) ; Chr(1) ; Chr(6);                '4th line of 6

      Case 7 : Lcd " " ; Chr(255) ; " ";                    '4th line of 7

      Case 8 : Lcd Chr(5) ; Chr(1) ; Chr(6);                '4th line of 8

      Case 9 : Lcd Chr(5) ; Chr(1) ; Chr(6)                 '4th line of 9

  End Select

  Next N

Lab_end_sub:

End Sub

End_big_number: