'Troredni format ispisa temperature u opsegu od -99.9 do 99.9C
'iz Single varijable i troredi format ispisa C

$regfile = "m328pdef.dat"
$crystal = 16000000
$swstack = 50
$hwstack = 40
$framesize = 64

'Mladen Cempuh , 11.2024.
'--------------------------------------------------------------
'DEFINIRANJE LCD DISPLEJA U 4 BITNOM RADU

Config Lcd = 20 * 4                                         ' izbor LCD2004

Config Lcdpin = Pin , Db4 = Portc.3 , Db5 = Portc.2 , Db6 = Portb.5 , Db7 = Portb.4 , Rs = Portc.5 , E = Portc.4
Cls
Cursor Off

'-------------------------------------------------------------
$include "3_rows_Single_99.9.inc"                           ' knjizica za troredni ispis decimalnog broja od -99.9 do 99.9 iz Single varijable
'-------------------------------------------------------------

Dim X As Single

'---------------------------------------------------------------
'Troredni ispis "C" na poziciji 1,16

Locate 1 , 16 : Lcd "o" ; Chr(255) ; Chr(1) ; Chr(4)

Locate 2 , 17 : Lcd Chr(255) ; "  "

Locate 3 , 17 : Lcd Chr(3) ; Chr(2) ; Chr(255)
'---------------------------------------------------------------

Locate 4 , 1 : Lcd "Big Number in 3 rows"

Do

 For X = -99.9 To 99.9 Step 8.2

 Big_number 1 , 1 , X                                       ' ispisi na poziciju y = 1, x = 1, decimalni broj u Single varijabli X

 Wait 2

 Next X

Loop

End